unit fmMain;

interface

uses
	{ Units de base }
  Windows, Messages, SysUtils, Classes, Controls, Forms, StdCtrls, ExtCtrls, XPMan, 
  { Synapse }
	HTTPSend, blcksock;

type
	TThreadTestProxy = class(TThread)
  private
  	fProxyLevel: integer; { 0: mort/ne rpond pas; 1: transparent; 2: anonyme; TODO: utiliser types numrs }
  protected
	  procedure Execute; override;
	public
    HttpProxyHost: string;
    HttpProxyPort: string;
    property ProxyLevel: integer read fProxyLevel;
    constructor Create;
  end;

  TfrmMain = class(TForm)
    Bevel1: TBevel;
    btnTestProxies: TButton;
    lblAllProxies: TLabel;
    lblAllProxiesTotal: TLabel;
    lblAnonymousProxies: TLabel;
    lblAnonymousProxiesTotal: TLabel;
    lblDeadProxies: TLabel;
    lblDeadProxiesTotal: TLabel;
    lblIPAddress: TLabel;
    lblTransparentProxies: TLabel;
    lblTransparentProxiesTotal: TLabel;
    memoAllProxies: TMemo;
    memoAnonymousProxies: TMemo;
    memoDeadProxies: TMemo;
    memoTransparentProxies: TMemo;
    XPManifest1: TXPManifest;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnTestProxiesClick(Sender: TObject);
  private
    { Private declarations }
    procedure TestProxyDone(Sender: TObject);
    procedure NewThreadTestProxy;
  public
    { Public declarations }
  end;

function iMin(const I, J: integer): integer;

const
	URL_SCRIPT = 'http://www.nomdomaine.com/test_ip.php'; { Url du script renvoyant l'adresse IP }
	MAX_THREADS = 12;		{ Nombre maximum de threads simultans pour le tlchargement (valeur totalement arbitraire) }

var
  frmMain: TfrmMain;
  slProxies: TStringList;
  sIPAddress: string;
  iProxyIndex, iProxiesNb, iProxiesTested: integer;
  bAborted: boolean;

implementation

{$R *.dfm}

{ ==================================================================================================================== }

function iMin(const I, J: integer): integer;
asm
                   // I in EAX
                   // J in EDX
	CMP EDX,EAX      // Compare  EDX and EAX
	CMOVL EAX,EDX    // Move if less (SF<>OF)
                   // Does not affect the destination operand if the
                   // condition is False.
end;

{ ==================================================================================================================== }

procedure TfrmMain.FormCreate(Sender: TObject);
begin
	Randomize;

  { Chargement de la liste des proxies  tester }
	slProxies := TStringList.Create;
  slProxies.LoadFromFile('Proxies.txt');
  slProxies.NameValueSeparator := ':';	{ Le Host et le Port sont spars par le signe deux points (:) }
  memoAllProxies.Lines.AddStrings(slProxies);

  iProxiesNb := slProxies.Count;
  if iProxiesNb > 0 then
  	lblAllProxiesTotal.Caption := Format('Total: %d', [iProxiesNb])
  else
  	lblAllProxiesTotal.Caption := 'Total: N/A';
  btnTestProxies.Enabled := iProxiesNb > 0;
end;

{ ==================================================================================================================== }

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
	slProxies.Clear;
  slProxies.Free;
end;

{ ==================================================================================================================== }

procedure TfrmMain.btnTestProxiesClick(Sender: TObject);
var
	sl: TStringList;
  i1, iMax: integer;
  bIPTestOk: boolean;
begin
	with (Sender as TButton) do begin
		if Tag = 0 then begin
      { Rcupration de l'IP }
      memoDeadProxies.Clear;
      memoTransparentProxies.Clear;
      memoAnonymousProxies.Clear;
      Enabled := FALSE;
      bIPTestOk := FALSE;
      with THTTPSend.Create do begin
      	sl := TStringList.Create;
        try
          if HTTPMethod('GET', URL_SCRIPT) then begin
            if ResultCode = 200 then begin
              sl.LoadFromStream(Document);
              sIPAddress := sl.ValueFromIndex[0];
              lblIPAddress.Caption := 'Adresse IP: ' + sIPAddress;
              bIPTestOk := TRUE;
            end
            else
              lblIPAddress.Caption := 'Problme lors de la rcupration de l''adresse IP !';
          end;
        finally
          sl.Free;
          Free;
        end;
      end;
      Enabled := TRUE;

      { Si la rcupration de l'IP a chou, on ne peut pas aller plus loin }
      if not bIPTestOk then
       Exit;

      { On dmarre les tests }
      Tag := 1;
      Caption := 'Arrter !';
    	bAborted := FALSE;

      iProxiesTested := 0;
      iProxyIndex := 0;
			iMax := iMin(slProxies.Count, MAX_THREADS);
	  	for i1 := 0 to iMax - 1 do
  			NewThreadTestProxy;
	  end
    else begin
    	{ On demande l'arrt des tests }
      bAborted := TRUE;
      Caption := 'Tester les proxies';
      Tag := 0;

      btnTestProxies.Enabled := FALSE;
    end;
  end;
end;

{ ==================================================================================================================== }

procedure TfrmMain.NewThreadTestProxy;
begin
  with TThreadTestProxy.Create do begin
    HttpProxyHost := slProxies.Names[iProxyIndex];
    HttpProxyPort := slProxies.ValueFromIndex[iProxyIndex];
    OnTerminate := TestProxyDone;
    Resume;	{ C'est parti ! }
  end;
	Inc(iProxyIndex);
end;

{ ==================================================================================================================== }
{ TThreadTestProxy                                                                                                     }
{ ==================================================================================================================== }

constructor TThreadTestProxy.Create;
begin
	inherited Create(TRUE);	{ Suspended }
  FreeOnTerminate := TRUE;

  fProxyLevel := 0; { Par dfaut, on considre le proxy comme mort/HS }
end;

{ ==================================================================================================================== }

procedure TThreadTestProxy.Execute;
var
	sl: TStringList;
  i1: integer;
begin
  inherited;

	with THTTPSend.Create do begin
  	// Timeout := 10;
    // UserAgent := HttpUserAgent;
    ProxyHost := HttpProxyHost;
    ProxyPort := HttpProxyPort;

  	sl := TStringList.Create;
  	try
    	if HTTPMethod('GET', URL_SCRIPT) then begin
        if ResultCode = 200 then begin
        	sl.LoadFromStream(Document);
	    	  for i1 := 0 to sl.Count - 1 do begin
          	{ Teste toutes les variables retournes pour la prsence de l'adresse IP sense tre cache }
          	if sl.ValueFromIndex[i1] = sIPAddress then begin
	          	fProxyLevel := 1;	{ Transparent }
              Break;
            end;
          end;
          { Si l'IP n'apparat pas, vrifie que les donnes transmises sont OK, en testant une chane spcifique }
          if fProxyLevel = 0 then
            if sl.Values['MaValeurTest'] = 'Blablabla' then
            	fProxyLevel := 2;	{ Anonyme }
        end;
      end;
    finally
    	sl.Free;
    	Free;
    end;
  end;
end;

{ ==================================================================================================================== }

procedure TfrmMain.TestProxyDone(Sender: TObject);
var
	s: string;
begin
	Inc(iProxiesTested);
	with TThreadTestProxy(Sender) do begin
  	s := HttpProxyHost + ':' + HttpProxyPort;
  	case ProxyLevel of
    	0: begin
      	memoDeadProxies.Lines.Add(s);
        lblDeadProxiesTotal.Caption := Format('Total: %d', [memoDeadProxies.Lines.Count]);
      end;
      1: begin
      	memoTransparentProxies.Lines.Add(s);
        lblTransparentProxiesTotal.Caption := Format('Total: %d', [memoTransparentProxies.Lines.Count]);
      end;
      else begin
      	memoAnonymousProxies.Lines.Add(s);
        lblAnonymousProxiesTotal.Caption := Format('Total: %d', [memoAnonymousProxies.Lines.Count]);
      end;
    end;
  end;

  { Aucune condition d'arrt n'est dtecte, on peut continuer... }
  if not (bAborted or (iProxyIndex >= iProxiesNb)) then
  	NewThreadTestProxy
  { Arrt demand, ou plus de proxy  tester }
  else begin
  	{ Interruption en douceur: on attend la terminaison de tous les threads et on ractive le bouton }
    if iProxiesTested = iProxyIndex then begin
    	with btnTestProxies do begin
	  		Caption := 'Tester les proxies';
        Enabled := TRUE;
  	    Tag := 0;
      end;
    end;
  end;
end;

{ ==================================================================================================================== }

end.
